\documentclass{article}

\newcounter{paramc}
\newenvironment{paramlist}
{\begin{list}{\bfseries\upshape \hspace{2em}Parameter \arabic{paramc}:}
{\usecounter{paramc}\setlength{\parsep}{0.0ex}\setlength}}
{\end{list}}

\newcommand{\ipcmsg}[1]{{\raggedleft\bfseries\upshape #1}}

\author{FancyMail Project}
\title{Server IPC Message Reference}

\begin{document}

\maketitle
\tableofcontents

\section{Introduction}

This document describes the messages that different
servers may interchange depending on the role they play,
it does not describe the format of the information or
the medium on wich it is transfered.

The messages are divided in diferent protocols, each
protocol describes 

\section{Conventions}

When describing the comunication examples between two process we will
define one process as a client (requesting a service) as the server,
the format to describe a message will be the following:

\begin{verbatim}
C: message name: parameter 1 ; parameter 2 ; parameter 3
S: message name: parameter 1 ; parameter 2 ; parameter 3
\end{verbatim}

Where C is client and S server.

\section{Common Messages}

\ipcmsg{ok}

A positive response to another mensage, should include a return value.

\begin{paramlist}
\item Return Value
\end{paramlist}

\ipcmsg{error}

An error message.

\begin{paramlist}
\item Message
\end{paramlist}

\section{Authentication Server}
\subsection{Messages}

\ipcmsg{verify}

Verify if a user exist, will return "ok" is the user
exist, error otherwise.

\begin{paramlist}
\item Username
\end{paramlist}

\ipcmsg{auth}

Will authenticate a given user, will return ok if the
user and password are right, error otherwise.

\begin{paramlist}
\item Username
\item Password
\end{paramlist}

\section{Mail Queue Server}

\subsection{Comunication Examples}
\subsubsection{Adding a message to a queue}

With a given queue named "incoming" we will push a message to it,
where C is the client and QS is the queue server:

\begin{verbatim}
C:  slot: incoming
QS: ok: /tmp/fmain/queues/incoming/212214962143124030
C:  push: incoming ; /tmp/fmain/queues/incoming/212214962143124030
QS: ok  
\end{verbatim}

\subsubsection{Getting a message from a queue}

With a given queue named "incoming" we will pop a message from it,
where C is the client and QS is the queue server:

\begin{verbatim}
C:  pop: incoming
QS: ok: /tmp/fmain/queues/incoming/212214962143124030
\end{verbatim}

\subsubsection{Subscribing to a queue}

With a given queue named "incoming" we will subscribe to it,
where C is the client and QS is the queue server:

\begin{verbatim}
C:  subscribe: incoming ; socket://127.0.0.1:14001
QS: ok
\end{verbatim}

Once the client is subscribed and there is new messages in the queue,
the queue server will connect back to the client and send the message
"alert", then the client may pop messages till it receives the error
message:

\begin{verbatim}
QS: alert: incoming
C: pop: incoming
QS: ok: /tmp/fmain/queues/incoming/212214962143124030
C: pop: incoming
QS: error
\end{verbatim}

\subsection{Messages}

\ipcmsg{slot}

Request a slot from the message queue, it will send
back an OK response with the filename to use, this
filename will be the identifier the requested slot.

After writing the data into the file you must send back
a the finishing message "push", in order to move the
message to the queue.

\begin{paramlist}
\item Queue Name
\end{paramlist}

\ipcmsg{push}

Tell the queue server that it can move a given message to
the queue, this means that we finished writing the data to
the file and it is closed.

\begin{paramlist}
\item Queue Name
\item Filaname
\end{paramlist}
  
\ipcmsg{pop}

Retrieve the next message in the queue, it will return an OK
message with the filename.

\begin{paramlist}
\item Queue Name
\end{paramlist}

\ipcmsg{subscribe}

Subscribe to a message queue, the subscriber will receive alerts
when there is new messages in the queue.

\begin{paramlist}
\item Queue Name
\item IPC Callback String
\end{paramlist}

\ipcmsg{unsuscribe}

Remove subscription to a queue. The IPC Callback String should
be exactly the same as given on subscription.

\begin{paramlist}
\item Queue Name
\item IPC Callback String
\end{paramlist}

\section{SMTP Out Server}

\subsection{Comunication Examples}
\subsection{Messages}

\ipcmsg{send}

Sends a message to another SMTP server.

\begin{paramlist}
\item From (address)
\item To (address)
\item Slot
\end{paramlist} 

\section{Mailbox Server}

\subsection{Comunication Examples}

\subsubsection{Listing a user mailbox}

Give a mailbox server MS and a client C:

\begin{verbatim}
C: list: user_john
MS: ok: 2
MS: mailinfo: 1 ; 120
MS: mailinfo: 2 ; 300
MS: ok
\end{verbatim}

\subsection{Messages}

\ipcmsg{list}

It will return ok message with the amount of emails
for a given user, after that it will push n "mailinfo"
message. On failture it will return error.

\begin{paramlist}
\item Username
\end{paramlist}

\ipcmsg{mailinfo}

Return message with a given email detail.

\begin{paramlist}
\item Message Number
\item Message Size (in octets)
\end{paramlist}

\ipcmsg{store}

Store an email, it will return ok if successful and
begin using raw operations till read 'Data Length' 
bytes.

\begin{paramlist}
\item To
\item Recipent
\item Data Length
\end{paramlist}

\ipcmsg{retr}

Retrieve an email for a given user. Should
return ok with the size of the email if the
email number is valid and then it will
start sending the email using raw operations. 
If the email number is invalid will return error.

\begin{paramlist}
\item Username
\item Message Number
\end{paramlist}

\ipcmsg{dele}

Delete an email for a given user. It will return
ok if the operation was sucessful, error otherwise
(when the message doesen't exist.

\begin{paramlist}
\item Username
\item Message Number
\end{paramlist}

\end{document}
